#pragma once
#include "CommonFunction.h"
#include <deque>
using namespace std;
class IPCPPlocicy
{
public:
	IPCPPlocicy(){}
	virtual ~IPCPPlocicy() {}
	virtual BOOL Add(CString strMyUserId, CString strContactId,
		const CTime& timeContact) = 0;
	virtual BOOL Delete(CString strMyUserId, CString strContactId) = 0;
	//virtual BOOL Get(CString myId, CString contactId) = 0;
	virtual BOOL GetAll(CString strMyUserId, deque<CString>* pDeqContactId) = 0;

protected:
	virtual BOOL Open()= 0;
	virtual BOOL Close() = 0;
};

class CSqlitePolicy	: public IPCPPlocicy
{
public:
	CSqlitePolicy(int nRecordSize = 10);

	virtual ~CSqlitePolicy();

	virtual BOOL Add(CString strMyUserId, CString strContactId,
		const CTime& timeContact);

	virtual BOOL Delete(CString strMyUserId, CString strContactId);
	virtual BOOL GetAll(CString strMyUserId, deque<CString>* pDeqContactId);

protected:
	virtual BOOL Open();
	virtual BOOL Close();

private:
	sqlite3	*m_pSQLite;
	BOOL m_bIsOpened;
	int m_nRecordSize;
};